package jp.littlesoft.gwttest1.server;

import java.lang.reflect.Field;
import jp.littlesoft.gwttest1.client.ImageSearchResultSet;
import org.xml.sax.helpers.DefaultHandler;

public class YahooImageSearchResultHandler extends DefaultHandler {
  private ImageSearchResultSet resultSet;
  private Object targetObj = null;
  private java.io.StringWriter sw = null;
  
  public YahooImageSearchResultHandler(ImageSearchResultSet resultSet) {
    this.resultSet = resultSet;
  }
  
  public void characters(char[] ch, int start, int length) throws org.xml.sax.SAXException {
    if (sw != null) {
      sw.append(new String(ch, start, length));
    }  
  }

  public void startElement(String uri, String localName, String qName, org.xml.sax.Attributes attributes) throws org.xml.sax.SAXException {
    if ("ResultSet".equals(qName)) {
      this.resultSet.firstResultPosition = Integer.parseInt(attributes.getValue("firstResultPosition"));
      this.resultSet.totalResultsAvailable = Integer.parseInt(attributes.getValue("totalResultsAvailable"));
      this.resultSet.totalResultsReturned  = Integer.parseInt(attributes.getValue("totalResultsReturned"));
    } else if ("Result".equals(qName)) {
      this.targetObj = new ImageSearchResultSet.Result();
      resultSet.array.add(this.targetObj);
    } else if ("Thumbnail".equals(qName)){
      this.targetObj = ((ImageSearchResultSet.Result)(resultSet.array.get(resultSet.array.size()-1))).thumbnail;
    } else {
      sw = new java.io.StringWriter();
    }
  }

  public void endElement(String uri, String localName, String qName) throws org.xml.sax.SAXException {
    if ("ResultSet".equals(qName)) {
      //
    } else if ("Result".equals(qName)) {
      //
    } else if ("Thumbnail".equals(qName)){
      this.targetObj = resultSet.array.get(resultSet.array.size()-1);
    } else {
      setValue(this.targetObj, qName, sw.toString());
    }
  }

  static void setValue(Object obj, String fieldName, String value) {
    try {
      String fname = fieldName.substring(0,1).toLowerCase() + fieldName.substring(1,fieldName.length());
      Field field = obj.getClass().getField(fname);
      if (field.getType().equals(int.class)) {
        field.setInt(obj, Integer.parseInt(value));
      } else {
        field.set(obj, value);
      }
    } catch (Exception x) {}
  }
}
